datacache <- new.env(hash=TRUE, parent=emptyenv())

scop_dbconn <- function() dbconn(datacache)
scop_dbfile <- function() dbfile(datacache)
scop_dbschema <- function(file="", show.indices=FALSE) dbschema(datacache, 
    file=file, show.indices=show.indices)
scop_dbInfo <- function() dbInfo(datacache)

.onLoad <- function(libname, pkgname)
{
    require("methods", quietly=TRUE)   
    warning(sprintf("\n*** Stale annotation package warning ***:\nThe package '%s' has not been updated by it's contributor.\nIt is out of date and may not be supported after Bioc release 2.5.\nIf you want a newer version you should use PAnnBuilder to make one.\n\n", pkgname))
    require("PAnnBuilder", quietly=TRUE)
    ## Connect to the SQLite DB
    dbfile <- system.file("extdata", "scop.sqlite", package="scop.db", 
        lib.loc=libname)
    assign("dbfile", dbfile, envir=datacache)
    dbconn <- dbFileConnect(dbfile)
    assign("dbconn", dbconn, envir=datacache)
    ## Create the AnnObj instances
    ann_objs <- createAnnObjs("SCOP", "scop", datacache, dbconn)    
    mergeToNamespaceAndExport(ann_objs, "scop.db" )
}

.onUnload <- function(libpath)
{
    dbFileDisconnect(scop_dbconn())
}

